<?php
session_start();
require_once "credentials.php";
?>
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Admin Panel</title>
    <link rel="stylesheet" href="css/adminNavbar.css">
    <link rel="stylesheet" href="css/adminTableUser.css">
    <link rel="stylesheet" href="css/logoutAdmin.css">
</head>
<body>
<div class="navbar">
    <a href="index.php?page=viewAdmin">Create</a>
    <a href="index.php?page=nodes">Nodes</a>
    <a href="index.php?page=deletePlant">Plants</a>
    <a href="index.php?page=adminSettings">Settings</a>
    <a href="index.php">Logout</a>
</div>

<div class='account'>
    You are logged in as <strong><?php echo $_SESSION['user_name']; ?></strong>
</div>

<h1 style="text-align: center">Plant Varieties</h1>
<div class="container">
    <table border="1" style="text-align: center">
        <thead>
        <tr>
            <th>Common Name</th>
            <th>Botanical Name</th>
            <th>Action</th>
        </tr>
        </thead>
        <tbody>
        <?php
        $dbc = mysqli_connect(DB_HOST, DB_USER, DB_PW, DB_NAME);
        if (!$dbc) {
            die('Connect Error (' . mysqli_connect_errno() . ') ' . mysqli_connect_error());
        }

        mysqli_set_charset($dbc, 'utf8');

        // *** Löschen der Pflanze ***
        if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['delete_plant'])) {
            $delete_id = intval($_POST['delete_plant']);  // Sicherstellen, dass es eine Zahl ist

            if ($delete_id > 0) {
                $delete_query = "DELETE FROM PlantVariety WHERE pk_plantVariety = ?";
                $delete_stmt = mysqli_prepare($dbc, $delete_query);

                if ($delete_stmt) {
                    mysqli_stmt_bind_param($delete_stmt, "i", $delete_id);

                    if (mysqli_stmt_execute($delete_stmt)) {
                        echo "<p style='color:green; text-align:center;'>Plant variety deleted successfully.</p>";
                    } else {
                        echo "<p style='color:red; text-align:center;'>Error deleting plant variety: " . mysqli_error($dbc) . "</p>";
                    }

                    mysqli_stmt_close($delete_stmt);
                } else {
                    echo "<p style='color:red; text-align:center;'>Error preparing statement: " . mysqli_error($dbc) . "</p>";
                }
            }

            ob_end_flush();  // Sicherstellen, dass der Header funktioniert
            header("Location: index.php?page=deletePlant");
            exit;
        }

        // *** Pflanzenarten abrufen ***
        $query = "SELECT pk_plantVariety, commonName, botanicalName FROM PlantVariety";
        $result = mysqli_query($dbc, $query);

        if ($result) {
            while ($row = mysqli_fetch_assoc($result)) {
                echo "<tr>";
                echo "<td>" . htmlspecialchars($row['commonName']) . "</td>";
                echo "<td>" . htmlspecialchars($row['botanicalName']) . "</td>";
                echo "<td>
                        <form method='post'>
                            <input type='hidden' name='delete_plant' value='" . $row['pk_plantVariety'] . "'>
                            <input type='submit' name='delete_submit' value='Delete' onclick='return confirm(\"Are you sure?\")'>
                        </form>
                      </td>";
                echo "</tr>";
            }
        } else {
            echo "<tr><td colspan='3'>No plant varieties found</td></tr>";
        }

        mysqli_close($dbc);
        ?>
        </tbody>
    </table>
</div>
</body>
</html>
