<?php
session_start();
require_once "credentials.php"; // Zum Laden der Datenbank-Verbindungsdetails
?>

<!doctype html>
<html lang="de">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Nodes anzeigen</title>
    <link rel="stylesheet" href="css/adminNavbar.css">
    <link rel="stylesheet" href="css/logoutAdmin.css">
    <link rel="stylesheet" href="css/adminTableUser.css">
    <link rel="stylesheet" href="css/nodeDetails.css">
</head>
<body>

<div class="navbar">
    <a href="index.php?page=viewAdmin">Create</a>
    <a href="index.php?page=nodes">Nodes</a>
    <a href="index.php?page=deletePlant">Plants</a>
    <a href="index.php?page=adminSettings">Settings</a>
    <a href="index.php">Logout</a>
</div>

<?php
echo "<div class='account'>You are logged in as <strong>" . $_SESSION['user_name'] . "</strong></div>";
?>

<?php
// Verbindung zur Datenbank herstellen
$dbc = mysqli_connect(DB_HOST, DB_USER, DB_PW, DB_NAME);

// Prüfen, ob die Verbindung funktioniert
if (mysqli_connect_errno()) {
    die('Verbindungsfehler (' . mysqli_connect_errno() . '): ' . mysqli_connect_error());
}

// Überprüfen, ob ein Löschbefehl übergeben wurde
if (isset($_GET['delete_node_id'])) {
    $nodeIdToDelete = $_GET['delete_node_id'];

    // SQL-Abfrage zum Löschen des Nodes
    $deleteQuery = "DELETE FROM Node WHERE pk_node = ?";
    $stmt = mysqli_prepare($dbc, $deleteQuery);

    if ($stmt) {
        mysqli_stmt_bind_param($stmt, 'i', $nodeIdToDelete);
        if (mysqli_stmt_execute($stmt)) {
            echo "<p class='success'>Node erfolgreich gelöscht.</p>";
        } else {
            echo "<p class='error'>Fehler beim Löschen des Nodes: " . mysqli_error($dbc) . "</p>";
        }
        mysqli_stmt_close($stmt);
    } else {
        echo "<p class='error'>Fehler bei der Vorbereitung der Löschabfrage: " . mysqli_error($dbc) . "</p>";
    }
}

// Überprüfen, ob der Benutzer für einen Node einen neuen Benutzer zugewiesen hat
if (isset($_POST['assign_user_to_node'])) {
    $nodeId = $_POST['node_id'];
    $newUserId = $_POST['new_user_id'];

    // SQL-Abfrage zum Zuweisen eines Benutzers zu einem Node
    $updateQuery = "UPDATE Node SET fk_operator_belongs = ? WHERE pk_node = ?";
    $stmt = mysqli_prepare($dbc, $updateQuery);

    if ($stmt) {
        mysqli_stmt_bind_param($stmt, 'ii', $newUserId, $nodeId);
        if (mysqli_stmt_execute($stmt)) {
            echo "<p class='success'>Node erfolgreich einem anderen Benutzer zugewiesen.</p>";
        } else {
            echo "<p class='error'>Fehler bei der Zuweisung des Nodes: " . mysqli_error($dbc) . "</p>";
        }
        mysqli_stmt_close($stmt);
    } else {
        echo "<p class='error'>Fehler bei der Vorbereitung der Zuweisungsabfrage: " . mysqli_error($dbc) . "</p>";
    }
}

// SQL-Abfrage, um alle Nodes und den zugewiesenen Benutzer zu erhalten
$query = "SELECT pk_node, name AS node_name, fk_operator_belongs, 
                 (SELECT CONCAT(firstname, ' ', lastname) FROM Operator WHERE pk_operator = fk_operator_belongs) AS assigned_user
          FROM Node ORDER BY pk_node";
$result = mysqli_query($dbc, $query);

// Überprüfen, ob die Abfrage erfolgreich war
if (!$result) {
    die('Fehler bei der Abfrage: ' . mysqli_error($dbc));
}

// SQL-Abfrage, um alle Benutzer für die Auswahl im Dropdown zu holen (user_id, firstname, lastname)
$userQuery = "SELECT pk_operator, firstname, lastname FROM Operator ORDER BY pk_operator";
$userResult = mysqli_query($dbc, $userQuery);

// Überprüfen, ob die Benutzerabfrage erfolgreich war
if (!$userResult) {
    die('Fehler bei der Abfrage der Benutzer: ' . mysqli_error($dbc));
}

echo "<h2>All Nodes</h2>";

if (mysqli_num_rows($result) > 0) {
    echo '<table>';
    echo '<tr>
            <th>Node ID</th>
            <th>Node Name</th>
            <th>Details</th>
            <th>Delete</th>
            <th>Select user</th>
            <th>Current User</th>
          </tr>';

    // Durch alle Ergebnisse iterieren und anzeigen
    while ($row = mysqli_fetch_assoc($result)) {
        echo '<tr>';
        echo '<td>' . $row['pk_node'] . '</td>';
        echo '<td>' . $row['node_name'] . '</td>';
        echo '<td>
                <a href="index.php?page=AdminNodeDetails&node_id=' . $row['pk_node'] . '">
                    <button type="button">Details</button>
                </a>
              </td>';

        // Löschen-Link hinzufügen
        echo '<td>
                <a href="index.php?page=nodes&delete_node_id=' . $row['pk_node'] . '" onclick="return confirm(\'Bist du sicher, dass du diesen Node löschen möchtest?\');">
                    <button type="button" style="background-color: red; color: white;">Löschen</button>
                </a>
              </td>';

        // Zuweisen eines Benutzers zum Node
        // Zuweisen eines Benutzers zum Node
        echo '<td>
        <form method="POST" action="index.php?page=nodes">
            <input type="hidden" name="node_id" value="' . $row['pk_node'] . '">
            <select name="new_user_id">
                <option value="">Select User...</option>';

    // Benutzerliste erneut abrufen, aber Admin (ID = 1) ausschließen
        $userQuery = "SELECT pk_operator, firstname, lastname FROM Operator WHERE pk_operator != 1 ORDER BY pk_operator";
        $userResult = mysqli_query($dbc, $userQuery);

        while ($userRow = mysqli_fetch_assoc($userResult)) {
            echo '<option value="' . $userRow['pk_operator'] . '">' . $userRow['firstname'] . ' ' . $userRow['lastname'] . '</option>';
        }

        echo '  </select>
        <button type="submit" name="assign_user_to_node">Assign</button>
    </form>
  </td>';


        // Aktuellen zugewiesenen Benutzer anzeigen
        echo '<td>' . ($row['assigned_user'] ? $row['assigned_user'] : 'Kein Benutzer zugewiesen') . '</td>';

        echo '</tr>';
    }

    echo '</table>';
} else {
    echo '<p>Keine Nodes gefunden.</p>';
}

// Verbindung zur Datenbank schließen
mysqli_close($dbc);
?>

</body>
</html>
