<?php
session_start();
?>
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Password Reset</title>
    <link rel="stylesheet" href="css/adminNavbar.css">
    <link rel="stylesheet" href="css/logoutAdmin.css">
    <link rel="stylesheet" href="css/adminTableUser.css">
</head>
<body>
<div class="navbar">
    <a href="index.php?page=viewAdmin">Create</a>
    <a href="index.php?page=nodes">Nodes</a>
    <a href="index.php?page=deletePlant">Plants</a>
    <a href="index.php?page=adminSettings">Settings</a>
    <a href="index.php">Logout</a>
</div>

<?php

    echo "<div class='account'>You are logged in as <strong>" . htmlspecialchars($_SESSION['user_name']) . "</strong></div>";


// Datenbankverbindung herstellen
require_once "credentials.php";
$dbc = mysqli_connect(DB_HOST, DB_USER, DB_PW, DB_NAME);
if (!$dbc) {
    die('Database connection failed: ' . mysqli_connect_error());
}

mysqli_set_charset($dbc, 'utf8');

// Passwort zurücksetzen
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    if (!empty($_POST['newPw']) && !empty($_POST['confirmPw'])) {
        $newPw = $_POST['newPw'];
        $confirmPw = $_POST['confirmPw'];
        $user_email = $_SESSION['user_email']; // E-Mail des eingeloggten Benutzers

        // Überprüfen, ob die Passwörter übereinstimmen
        if ($newPw !== $confirmPw) {
            echo "<p style='color: red;'>Passwords do not match. Please try again.</p>";
        } else {
            // Passwort sicher hashen
            $hashed_password = password_hash($newPw, PASSWORD_DEFAULT);

            // Query vorbereiten und ausführen
            $update_query = "UPDATE Operator SET passwordHash = ? WHERE emailAddress = ?";
            $update_stmt = mysqli_prepare($dbc, $update_query);
            if ($update_stmt) {
                mysqli_stmt_bind_param($update_stmt, "ss", $hashed_password, $user_email);
                if (mysqli_stmt_execute($update_stmt)) {
                    echo "<p style='color: green;'>Password has been reset successfully.</p>";
                } else {
                    echo "<p style='color: red;'>Error: Could not update password. Please try again.</p>";
                }
                mysqli_stmt_close($update_stmt);
                if (!mysqli_stmt_execute($update_stmt)) {
                    echo "<p style='color: red;'>Error: Could not update password. " . mysqli_error($dbc) . "</p>";
                }

            } else {
                echo "<p style='color: red;'>Error preparing the query.</p>";
            }
        }
    } else {
        echo "<p style='color: red;'>Please fill in all fields.</p>";
    }
}


mysqli_close($dbc);

?>

<form method="POST" action="">
    <label for="newPw">New Password:</label>
    <input type="password" id="newPw" name="newPw" required><br>

    <label for="confirmPw">Confirm New Password:</label>
    <input type="password" id="confirmPw" name="confirmPw" required><br>

    <button type="submit">Reset Password</button>
</form>

</body>
</html>
