<?php
session_start();
?>
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
    <link rel="stylesheet" href="css/adminNavbar.css">
    <link rel="stylesheet" href="css/adminTableUser.css">
    <link rel="stylesheet" href="css/logoutAdmin.css">
</head>
<body>
<div class="navbar">
    <a href="index.php?page=viewAdmin">Create</a>
    <a href="index.php?page=nodes">Nodes</a>
    <a href="index.php?page=deletePlant">Plants</a>
    <a href="index.php?page=adminSettings">Settings</a>
    <a href="index.php">Logout</a>
</div>

<div class='account'>
    You are logged in as <strong><?php echo $_SESSION['user_name']; ?></strong>
</div>

<div class="container">
    <div class="form-container">
        <form method="post">
            <h1>Create new User</h1>
            <label for="email">Email-Address:</label>
            <input id="email" type="email" name="DATA_email">

            <label for="firstname">Firstname:</label>
            <input id="firstname" type="text" name="DATA_firstname">

            <label for="lastname">Lastname:</label>
            <input id="lastname" type="text" name="DATA_lastname">

            <label for="password">Password:</label>
            <input id="password" type="password" name="DATA_pw">

            <input id="submit" type="submit" value="Create" name="Button_submit">
        </form>

        <?php
        require_once "credentials.php";

        if (isset($_POST["Button_submit"])) {
            $email = $_POST["DATA_email"];
            $firstname = $_POST["DATA_firstname"];
            $lastname = $_POST["DATA_lastname"];
            $password = $_POST["DATA_pw"];

            // Passwort hashen
            $hashed_password = password_hash($password, PASSWORD_DEFAULT);

            // Verbindung zur Datenbank herstellen
            $dbc = mysqli_connect(DB_HOST, DB_USER, DB_PW, DB_NAME);

            if (!$dbc) {
                die('Connect Error (' . mysqli_connect_errno() . ') ' . mysqli_connect_error());
            }

            mysqli_set_charset($dbc, 'utf8');

            // Benutzer in die Tabelle "Operator" einfügen
            $query = "INSERT INTO Operator (emailAddress, firstname, lastname, passwordHash) VALUES (?, ?, ?, ?)";

            $statement = mysqli_prepare($dbc, $query);

            if (!$statement) {
                die("Wrong SQL: $query Error: " . mysqli_error($dbc));
            }

            mysqli_stmt_bind_param($statement, "ssss", $email, $firstname, $lastname, $hashed_password);

            if (mysqli_stmt_execute($statement)) {
                echo "User successfully created.";
            } else {
                echo "Error creating user: " . mysqli_error($dbc);
            }

            mysqli_stmt_close($statement);
            mysqli_close($dbc);
        }
        ?>
    </div>

    <div class="table-container">
        <?php
        require_once "credentials.php";

        // Verbindung zur Datenbank herstellen
        $dbc = mysqli_connect(DB_HOST, DB_USER, DB_PW, DB_NAME);
        if (!$dbc) {
            die('Connect Error (' . mysqli_connect_errno() . ') ' . mysqli_connect_error());
        }

        mysqli_set_charset($dbc, 'utf8');

        // Benutzer löschen
        if (isset($_POST['delete_user'])) {
            $delete_email = $_POST['delete_user'];
            $delete_query = "DELETE FROM Operator WHERE emailAddress = ?";
            $delete_stmt = mysqli_prepare($dbc, $delete_query);
            mysqli_stmt_bind_param($delete_stmt, "s", $delete_email);
            if (mysqli_stmt_execute($delete_stmt)) {
                echo "User with email $delete_email deleted successfully.";
            } else {
                echo "Error deleting user: " . mysqli_error($dbc);
            }
            mysqli_stmt_close($delete_stmt);
        }

        // Alle Benutzer aus der Tabelle "Operator" abrufen
        $query = "SELECT emailAddress, firstname, lastname FROM Operator";
        $result = mysqli_query($dbc, $query);

        if ($result) {
            echo "<h1>All Users</h1>";
            echo "<table>";
            echo "<tr><th>Email</th><th>Firstname</th><th>Lastname</th><th>Action</th></tr>";

            while ($row = mysqli_fetch_assoc($result)) {
                echo "<tr><td>" . $row['emailAddress'] . "</td><td>" . $row['firstname'] . "</td><td>" . $row['lastname'] . "</td><td>";
                echo "<form method='post' style='display:inline;'>";
                echo "<input type='hidden' name='delete_user' value='" . $row['emailAddress'] . "'>";
                echo "<input type='submit' value='Delete'>";
                echo "</form></td></tr>";
            }

            echo "</table>";
        } else {
            echo "Error retrieving users: " . mysqli_error($dbc);
        }

        mysqli_close($dbc);
        ?>

    </div>
</div>
</body>
</html>
