<?php
session_start();
?>
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Login</title>

    <style>
        img {
            max-height: 200px; /* limit the image height to 180px */
            width: auto; /* maintain aspect ratio */
        }

        h1 {
            text-align: center;
            margin-top: 20px;
        }
    </style>
</head>
<body>
    <img src="images/logo/800/logo_tp.png" alt="Plantimeter Logo">
    <h1>Welcome to Plantimeter</h1>

<form method="post">

    <label for="email">Email-Address: </label>
    <input id="email" type="email" name="DATA_email">
    <br>
    <label for="pw">Password: </label>
    <input id="pw" type="password" name="DATA_pw">
    <br>

    <input id="submitLogin" type="submit" name="BUTTON_login" value="Einloggen">
</form>

<?php
require_once "credentials.php";

$dbc = mysqli_connect(DB_HOST, DB_USER, DB_PW, DB_NAME);

if (!$dbc) {
    die('Connect Error (' . mysqli_connect_errno() . ') ' . mysqli_connect_error());
}

mysqli_set_charset($dbc, 'utf8');

if (isset($_POST["BUTTON_login"])) {
    $email = $_POST["DATA_email"];
    $pw = $_POST["DATA_pw"];

    // Query: Passwort-Hash, Vorname, Nachname, ID abrufen
    $query = "SELECT passwordHash, firstname, lastname, pk_operator FROM Operator WHERE emailAddress = ?";

    $statement = mysqli_prepare($dbc, $query);

    if (!$statement) {
        die("Wrong SQL: $query Error: " . mysqli_error($dbc));
    }

    mysqli_stmt_bind_param($statement, "s", $email);

    mysqli_stmt_execute($statement);
    mysqli_stmt_bind_result($statement, $hashed_pw, $firstname, $lastname, $pk_operator);

    if (mysqli_stmt_fetch($statement)) {
        // Passwort abgleichen
        if (password_verify($pw, $hashed_pw)) {
            // In der Session speichern
            $_SESSION['user_name'] = $firstname . ' ' . $lastname;

            if ($pk_operator == 1) {
                // Admin-Weiterleitung
                header("Location: index.php?page=viewAdmin");
                $_SESSION['operator_id']=1;
            } else {
                // Normale Benutzer-Weiterleitung
                header("Location: index.php?page=viewUser");
                $_SESSION['operator_id']= $pk_operator;
            }
            exit();
        } else {
            echo "Falsches Passwort.";
        }
    } else {
        echo "E-Mail-Adresse nicht gefunden.";
    }

    mysqli_stmt_close($statement);
}

mysqli_close($dbc);
?>
</body>
</html>
